// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "GameFramework/GameModeBase.h"
#include "ToonTanksGameMode.generated.h"

/**
 * 
 */
UCLASS()
class TOONTANKS_API AToonTanksGameMode : public AGameModeBase
{
	GENERATED_BODY()

public:
	// Handles input or something after Actor died.
	void ActorDied(AActor* DeadActor);

protected:
	virtual void BeginPlay() override;

	// function for Start Game Blueprint Event
	UFUNCTION(BlueprintImplementableEvent)
	void StartGame();
	
private:
	// Tank Pointer for DeadActor which is ATank.
	UPROPERTY()
	class ATank* Tank;

	// ToonTanksPlayerController Pointer of player pawn.
	UPROPERTY()
	class AToonTanksPlayerController* PlayerController;

	// Delay time for starting game
	float StartDelay = 3.f;

	// Handles Game Start Action
	void HandleGameStart();
	
};
